// $Id: audslmon_u.i,v 1.2 2004/11/26 18:08:50 gson Exp $

// SWIG interface definition for user-mode audsl status monitor

%module audslmon_u

struct UserModeAudslModem *audsl_attach_shm(int shmid);
int audsl_shmget();
void audsl_shmrm(int shmid);


// $Id: audslmon_u.i,v 1.2 2004/11/26 18:08:50 gson Exp $
//
// SWIG interface definition for audsl status monitor.
// 

%{
#include "monitor.h"
%}

// Suppress generation of default constructor in SWIG
%nodefault;

struct UserModeAudslModem {
    char *get_hs_state();
    char *get_hs_role();
    char *get_rx_state();
    int get_ec_offset();
    float get_input_gain(); 
    float get_post_ec_gain();
    int get_ec_length(); 
    float get_ec_tap(int i, int dim); 
    int get_eq_length(); 
    float get_eq_tap(int i, int dim);
    int get_tx_underruns();
    int get_rx_overruns();
    int get_tx_packets();
    int get_rx_packets();
    double get_fqest();
    float get_rms_error();
    int get_n_retrains();
    bool get_init_done();
    char *get_last_error();
};

