/* daemon.c -- simple replacement for the 4.4BSD daemon() function */

#include <sys/types.h>
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif

int daemon(int nochdir, int noclose) 
{
    switch (fork()) {
    case -1:
	return -1;
    case 0: /* child */
	break;
    default: /* parent */
	exit(0);
    }

    if (! nochdir)
	chdir("/");

#ifdef SETPGRP_VOID
    setpgrp();
#else
    if ((tty=open("/dev/tty", 0, 0)) != -1) {
	ioctl(tty, TIOCNOTTY, (struct sgttyb *) 0);
	(void) close(tty);
    } else {
	if(setpgrp(0, 0)) 
	    error("setpgrp");
    }
#endif

#ifdef HAVE_SETSID
    setsid();
#endif
    
    if (! noclose) {
	int i;
	for (i = 0; i < 3; i++)
	    close(i);
    }
}
  
