// $Id: gain.h,v 1.5 2006/08/17 15:01:54 gson Exp $
//
// Abstract interface to objects having a settable gain.
//
// (C) Copyright 1999 Araneus Information Systems Oy.  All rights reserved.
// Please refer to the file COPYRIGHT for detailed copyright information.
//

#ifndef _GAIN_H
#define _GAIN_H

// The gain takes on a number of discrete values, from
// 0 to (N_GAIN_STEPS-1).

#define N_GAIN_STEPS 48

class Gain {
public:
    virtual ~Gain() { }
    virtual void reset_gain() = 0;
    virtual void set_gain(int) = 0;
};

#endif
