// $Id: handshake.h,v 1.15 1999/01/28 21:33:18 gson Exp $
//
// The modem handshake protocol state machine. 
//
// (C) Copyright 1999 Araneus Information Systems Oy.  All rights reserved.
// Please refer to the file COPYRIGHT for detailed copyright information.
//

#include "dsp.h"
#include "pll.h"
#include "lfsr.h"
#include "gain.h"
#include "protocol.h"
#include "kernels.h"

enum HandshakeState {
    HS_STATE_TRY_A,
    HS_STATE_DRAIN_A,
    HS_STATE_TRY_B,
    HS_STATE_DRAIN_B,
    HS_STATE_HEARD_A,
    HS_STATE_HEARD_B,
    HS_STATE_PRE_AGC_WAIT,
    HS_STATE_AGC,
    HS_STATE_SILENT,
    HS_STATE_END,
};

enum Identity { ID_X, ID_A, ID_B };

class HandshakeStateMachine {
public:
    HandshakeStateMachine(Gain &rec_gain);
    void reset();
    float run(float input);
    
    HandshakeState state;
    typedef KCFIR<float, float, GaussianWindowedBandpassKernel, 32, 256> Bandpass;
    Bandpass filter_a, filter_b;
    PLL pll_a, pll_b;
    Osc osc_a, osc_b;
    unsigned int rng;
    int nsamp;
    int nlisten;
    Identity identity;
    LFSR<1> lfsr;
    float inmin, inmax;
    int bestgain;
    Gain &gain;
};


    



