// $Id: kernels.h,v 1.2 1999/01/28 21:33:18 gson Exp $
//
// Filter kernels.
//
// (C) Copyright 1999 Araneus Information Systems Oy.  All rights reserved.
// Please refer to the file COPYRIGHT for detailed copyright information.
//

#ifndef _KERNELS_H
#define _KERNELS_H

#include "dsp.h"
#include "window-functions.h"

class GaussianWindowedBandpassKernel {
public:
    GaussianWindowedBandpassKernel(double lo_cut, double hi_cut,
				   int ntaps, double alpha)
	: lo(lo_cut), hi(hi_cut), n(ntaps), window(alpha) { }
    double operator()(double i) const {
	// Amplitude normalized lowpass kernel
	double hp = sinc(i * hi) * hi;
	// Amplitude normalized highpass kernel
	double lp = lo ? sinc(i * lo) * lo : 0;
	return (hp - lp) * window((double) i / (n * 0.5));
    }
    double lo, hi;
    int n;
    GaussianWindow window;
};

#endif
