// $Id: lfsr.h,v 1.11 1999/01/28 21:33:19 gson Exp $
//
// Linear Feedback Shift Register Pseudrandom Generator.
//
// (C) Copyright 1999 Araneus Information Systems Oy.  All rights reserved.
// Please refer to the file COPYRIGHT for detailed copyright information.
//

#ifndef _LFSR_H
#define _LFSR_H

// This is based on the v.29 scrambler.

#include "scrambler.h"

template <int BITS>
class LFSR {
public:
    LFSR() { reset(); }
    void reset() { scrambler.s = 0xDEADBEEF; }
    int operator()() {
	int result = 0;
	for (int i = 0; i < BITS ; i++) {
	    result <<= 1;
	    result |= scrambler(1);
	}
	return result;
    }
private:
    V29Scrambler scrambler;
};

#endif
