// $Id: monitor.h,v 1.11 1999/01/28 21:33:20 gson Exp $
//
// Interface to C++ part of the Tcl-based modem monitor program.
//
// (C) Copyright 1999 Araneus Information Systems Oy.  All rights reserved.
// Please refer to the file COPYRIGHT for detailed copyright information.
//

// These functions are made callable from Tcl through SWIG-generated
// stubs.

//////////////////////////////////////////////////////////////////////////
//
// Interface to a user-mode modem through SYSV shared memory.
//

#include "usermode-modem.h"

// Create a shared memory segment of a size and type suitable
// for storing a modem data structure.  Return the shared memory ID.
int audsl_shmget();

// Attach the given shared memory segment and return
// a pointer to the modem data structure in it.
UserModeAudslModem *audsl_attach_shm(int shmid);

// Remove the given shared memory segment.
void audsl_shmrm(int shmid);

//////////////////////////////////////////////////////////////////////////
//
// Interface to a kernel-mode modem if configured, 
// by memory mapping /dev/kmem.
//

#ifdef KERNELMODE

#include "kernelmode-modem.h"

// Attach to a modem in kernel memory.
KernelModeAudslModem *audsl_attach_kmem(char *ifname);

#endif



