// $Id: open-audio.h,v 1.7 2004/11/26 20:07:36 gson Exp $
//
// Open the audio device.
//
// (C) Copyright 1999 Araneus Information Systems Oy.  All rights reserved.
// Please refer to the file COPYRIGHT for detailed copyright information.
//

#ifndef _OPEN_AUDIO_H
#define _OPEN_AUDIO_H

#include <sys/ioctl.h>
#include <sys/time.h>
#include <sys/types.h>

#include <errno.h>
#include <fcntl.h>
#include <stdlib.h>
#include <string.h> // strerror
#include <unistd.h>

inline int
open_audio(char *dev_audio)
{
    if (strcmp(dev_audio, "-") == 0) {
	return 0; // stdin
    } else {
	int audio_fd = open(dev_audio, O_RDWR);
	if (audio_fd < 0) {
	    fprintf(stderr, "%s: open: %s\n",
		    dev_audio, strerror(errno));
	    exit(1);
	}
	return audio_fd;
    }
}

#endif
