// Machine generated by gen-pr-coders.tcl.  Do not edit.



extern float NullCoderPCF[];

template <class T>
class NullCoder: public PRCoder<T, 0> {
public:
    float gain() { return 1; }
    float inv_gain() { return 1.0; }
    T convolve() {
        return 

0
;
    }
    T encode(T input) { T r = input + convolve(); push(input); return r; }
    static int n() { return 0; }
    static float *pcf() { return NullCoderPCF; }
};



extern float DuoBinaryCoderPCF[];

template <class T>
class DuoBinaryCoder: public PRCoder<T, 1> {
public:
    float gain() { return 2; }
    float inv_gain() { return 0.5; }
    T convolve() {
        return 

              + (*this)[0] 
;
    }
    T encode(T input) { T r = input + convolve(); push(input); return r; }
    static int n() { return 1; }
    static float *pcf() { return DuoBinaryCoderPCF; }
};



extern float ModifiedDuoBinaryCoderPCF[];

template <class T>
class ModifiedDuoBinaryCoder: public PRCoder<T, 2> {
public:
    float gain() { return 2; }
    float inv_gain() { return 0.5; }
    T convolve() {
        return 

              - (*this)[1] 
;
    }
    T encode(T input) { T r = input + convolve(); push(input); return r; }
    static int n() { return 2; }
    static float *pcf() { return ModifiedDuoBinaryCoderPCF; }
};



extern float BACoderPCF[];

template <class T>
class BACoder: public PRCoder<T, 9> {
public:
    float gain() { return 4.32355; }
    float inv_gain() { return 0.231291; }
    T convolve() {
        return 

              +0.776883f * (*this)[0] 
              -0.682515f * (*this)[1] 
              -0.881991f * (*this)[2] 
              +0.151158f * (*this)[3] 
              +0.089377f * (*this)[4] 
              -0.043660f * (*this)[5] 
              +0.163216f * (*this)[6] 
              -0.132246f * (*this)[7] 
              -0.402503f * (*this)[8] 
;
    }
    T encode(T input) { T r = input + convolve(); push(input); return r; }
    static int n() { return 9; }
    static float *pcf() { return BACoderPCF; }
};



extern float AuDSL1CoderPCF[];

template <class T>
class AuDSL1Coder: public PRCoder<T, 3> {
public:
    float gain() { return 4; }
    float inv_gain() { return 0.25; }
    T convolve() {
        return 

              + (*this)[0] 
              - (*this)[1] 
              - (*this)[2] 
;
    }
    T encode(T input) { T r = input + convolve(); push(input); return r; }
    static int n() { return 3; }
    static float *pcf() { return AuDSL1CoderPCF; }
};



extern float AuDSL2CoderPCF[];

template <class T>
class AuDSL2Coder: public PRCoder<T, 4> {
public:
    float gain() { return 4; }
    float inv_gain() { return 0.25; }
    T convolve() {
        return 

              -2.000000f * (*this)[1] 
              + (*this)[3] 
;
    }
    T encode(T input) { T r = input + convolve(); push(input); return r; }
    static int n() { return 4; }
    static float *pcf() { return AuDSL2CoderPCF; }
};



extern float AuDSL3CoderPCF[];

template <class T>
class AuDSL3Coder: public PRCoder<T, 8> {
public:
    float gain() { return 3.06541; }
    float inv_gain() { return 0.326221; }
    T convolve() {
        return 

              -1.417309f * (*this)[1] 
              +0.264592f * (*this)[3] 
              +0.311560f * (*this)[5] 
              +0.071949f * (*this)[7] 
;
    }
    T encode(T input) { T r = input + convolve(); push(input); return r; }
    static int n() { return 8; }
    static float *pcf() { return AuDSL3CoderPCF; }
};



extern float AuDSL4CoderPCF[];

template <class T>
class AuDSL4Coder: public PRCoder<T, 12> {
public:
    float gain() { return 5.07619; }
    float inv_gain() { return 0.196998; }
    T convolve() {
        return 

              -2.159685f * (*this)[1] 
              +1.015083f * (*this)[3] 
              +0.522542f * (*this)[5] 
              -0.223862f * (*this)[7] 
              -0.135674f * (*this)[9] 
              -0.019363f * (*this)[11] 
;
    }
    T encode(T input) { T r = input + convolve(); push(input); return r; }
    static int n() { return 12; }
    static float *pcf() { return AuDSL4CoderPCF; }
};



extern float AuDSL5CoderPCF[];

template <class T>
class AuDSL5Coder: public PRCoder<T, 6> {
public:
    float gain() { return 3.0; }
    float inv_gain() { return 0.333333; }
    T convolve() {
        return 

              -1.500000f * (*this)[1] 
              +0.500000f * (*this)[5] 
;
    }
    T encode(T input) { T r = input + convolve(); push(input); return r; }
    static int n() { return 6; }
    static float *pcf() { return AuDSL5CoderPCF; }
};



extern float AuDSL6CoderPCF[];

template <class T>
class AuDSL6Coder: public PRCoder<T, 8> {
public:
    float gain() { return 6.0; }
    float inv_gain() { return 0.166667; }
    T convolve() {
        return 

              -2.666700f * (*this)[1] 
              +2.000000f * (*this)[3] 
              -0.333300f * (*this)[7] 
;
    }
    T encode(T input) { T r = input + convolve(); push(input); return r; }
    static int n() { return 8; }
    static float *pcf() { return AuDSL6CoderPCF; }
};



extern float AuDSL7CoderPCF[];

template <class T>
class AuDSL7Coder: public PRCoder<T, 8> {
public:
    float gain() { return 5.984; }
    float inv_gain() { return 0.167112; }
    T convolve() {
        return 

              -2.339000f * (*this)[1] 
              +1.024000f * (*this)[3] 
              +0.968000f * (*this)[5] 
              -0.653000f * (*this)[7] 
;
    }
    T encode(T input) { T r = input + convolve(); push(input); return r; }
    static int n() { return 8; }
    static float *pcf() { return AuDSL7CoderPCF; }
};



extern float AuDSL8CoderPCF[];

template <class T>
class AuDSL8Coder: public PRCoder<T, 12> {
public:
    float gain() { return 16.6103; }
    float inv_gain() { return 0.0602036; }
    T convolve() {
        return 

              -3.887614f * (*this)[1] 
              +5.915042f * (*this)[3] 
              -3.868673f * (*this)[5] 
              +1.392121f * (*this)[9] 
              -0.546780f * (*this)[11] 
;
    }
    T encode(T input) { T r = input + convolve(); push(input); return r; }
    static int n() { return 12; }
    static float *pcf() { return AuDSL8CoderPCF; }
};



extern float AuDSL9CoderPCF[];

template <class T>
class AuDSL9Coder: public PRCoder<T, 10> {
public:
    float gain() { return 15.8398; }
    float inv_gain() { return 0.0631321; }
    T convolve() {
        return 

              +2.941688f * (*this)[0] 
              +3.262537f * (*this)[1] 
              +0.453213f * (*this)[2] 
              -2.434152f * (*this)[3] 
              -1.958337f * (*this)[4] 
              +0.093873f * (*this)[5] 
              +0.121526f * (*this)[6] 
              -1.328719f * (*this)[7] 
              -1.605431f * (*this)[8] 
              -0.640445f * (*this)[9] 
;
    }
    T encode(T input) { T r = input + convolve(); push(input); return r; }
    static int n() { return 10; }
    static float *pcf() { return AuDSL9CoderPCF; }
};



extern float AuDSL10CoderPCF[];

template <class T>
class AuDSL10Coder: public PRCoder<T, 12> {
public:
    float gain() { return 9.22452; }
    float inv_gain() { return 0.108407; }
    T convolve() {
        return 

              +1.998708f * (*this)[0] 
              +1.121747f * (*this)[1] 
              -0.901869f * (*this)[2] 
              -1.254586f * (*this)[3] 
              -0.046690f * (*this)[4] 
              +0.144024f * (*this)[5] 
              -0.527093f * (*this)[6] 
              -0.255904f * (*this)[7] 
              +0.318220f * (*this)[8] 
              -0.181117f * (*this)[9] 
              -0.871441f * (*this)[10] 
              -0.603115f * (*this)[11] 
;
    }
    T encode(T input) { T r = input + convolve(); push(input); return r; }
    static int n() { return 12; }
    static float *pcf() { return AuDSL10CoderPCF; }
};

