// $Id: pr.h,v 1.36 1999/01/28 21:33:23 gson Exp $
//
// Partial response coders and decoders.
//
// (C) Copyright 1999 Araneus Information Systems Oy.  All rights reserved.
// Please refer to the file COPYRIGHT for detailed copyright information.
//

#ifndef _PR_H
#define _PR_H

#include <assert.h>

#include "dsp.h"

// Base class for all partial response coders.

template <class T, int N>
class PRCoder: public ContiguousSignalBuffer<T, N, 10*N> {
public:
    static int n() { return N; }
};

// Include machine-generated coder class definitions.
#include "pr-coders.h"

// Decide which coder to use by the shorthand name of "Coder<T>".
// This is the one the PR-PAM modem will actually use.

template<class T> class Coder: public AuDSL2Coder<T> { };

#endif
