// $Id: qam-mapper.h,v 1.4 1999/01/28 21:33:24 gson Exp $
//
// Symbol mapper and slicer for QAM.
//
// (C) Copyright 1999 Araneus Information Systems Oy.  All rights reserved.
// Please refer to the file COPYRIGHT for detailed copyright information.
//

#ifndef _QAM_MAPPER_H
#define _QAM_MAPPER_H

#include <assert.h>

template <class T, int BITS_PER_SYMBOL>
class QAMMapper {
public:
    QAMMapper() { reset(); }
    void reset() { y = 0; }
    complex<T> operator()(int bits) {
	assert(BITS_PER_SYMBOL == 2);
	assert (bits < 4);
	int hibits = bits;
#if 0
	// As in ITU-T v.32
	static char table[16] = {
	    1, 3, 0, 2,
	    0, 1, 2, 3,
	    3, 2, 1, 0,
	    2, 0, 3, 1
        };
	y = table[hibits << 2 | y];
#else
	y = hibits;
#endif
	
	T re = (y & 0x01) ? 1 : -1;
	T im = (y & 0x02) ? 1 : -1;
	return complex<T>(re, im);
    }
private:
    int y;
};

template <class T, int BITS_PER_SYMBOL>
class QAMSlicer {
public:
    int operator()(complex<T> sample) {
	assert(BITS_PER_SYMBOL == 2);
	return
	    (sample.real() > 0) |
	    (sample.imag() > 0) << 1;
    }
};

#endif
