// $Id: qam-protocol.h,v 1.13 1999/01/28 21:33:24 gson Exp $
//
// Protocol parameters for QAM modem.
//
// (C) Copyright 1999 Araneus Information Systems Oy.  All rights reserved.
// Please refer to the file COPYRIGHT for detailed copyright information.
//

#ifndef _QAM_PROTOCOL_H
#define _QAM_PROTOCOL_H

#include "scrambler.h"
#include "lfsr.h"

#define N_PILOT_SYMBOLS 20000     // Must be even
#define N_REVERSAL_SYMBOLS 2      // Must be even
#define N_TRAINING_SYMBOLS 40000
#define N_BITS_PER_SYMBOL 2

// There are three samples to one symbol.
#define BITS_PER_SAMPLE (N_BITS_PER_SYMBOL / 3.0)

class QAMScrambler: public V29Scrambler { };
class QAMDescrambler: public V29Descrambler { };
class QAMTrainingSequence: public LFSR<N_BITS_PER_SYMBOL> { };

#endif
