// $Id: resample-pull.h,v 1.11 2006/08/17 15:01:54 gson Exp $
//
// "Pull-mode" sample rate converter.
//
// (C) Copyright 1999 Araneus Information Systems Oy.  All rights reserved.
// Please refer to the file COPYRIGHT for detailed copyright information.
//

// A "pull-mode" sample rate converter produces a single
// result per call, and consumes a variable number of input
// samples.
  
#include "resample.h"

// Convert the sampling rate of a signal with sample type T.
// The input is read by calling the object "in", of type I.

template <class T, class I, class ImpulseResponseFunction, int NTAPS,
    int NPHASES, int LOG2_NPHASES>
class PullSampleRateConverter:
public SampleRateConverter<T, ImpulseResponseFunction, NTAPS, NPHASES, LOG2_NPHASES>
{
public:
    PullSampleRateConverter(I &input)
	: inp(input) { }

    T operator()() {
	while (this->phase >= (Phase) 1.0) {
	    SampleRateConverter<T, ImpulseResponseFunction, NTAPS, NPHASES, LOG2_NPHASES>::push(inp());
	    this->phase -= Phase(1.0);
	}
	T r = this->filter();
	this->phase += this->fq;
	return r;
    }

private:
    I &inp;
};

