// $Id: resample-push.h,v 1.11 2006/08/17 15:01:54 gson Exp $
//
// "Push-mode" sample rate converter.
//
// (C) Copyright 1999 Araneus Information Systems Oy.  All rights reserved.
// Please refer to the file COPYRIGHT for detailed copyright information.
//

// A "push-mode" sample rate converter consumes a single sample
// per call, and produces a variable number of output samples.

#include "resample.h"

// Convert the sampling rate of a signal with sample type T.
// The input is generated by calling the object "out", of type O.

template <class T, class O, class ImpulseResponseFunction,
	  int NTAPS, int NPHASES, int LOG2_NPHASES>
class PushSampleRateConverter:
public SampleRateConverter<T, ImpulseResponseFunction, NTAPS, NPHASES, LOG2_NPHASES>
{
public:
    PushSampleRateConverter(O &output)
	: out(output) { }

    void push(T s) {
	while (this->phase < 1) {
	    out.push(this->filter());
	    this->phase += this->fq;
	}
	SampleRateConverter<T, ImpulseResponseFunction, NTAPS, NPHASES, LOG2_NPHASES>::push(s);
	this->phase -= 1;
    }
private:    
    O &out;
};

