// $Id: scrambler.h,v 1.5 1999/01/28 21:33:26 gson Exp $
//
// CCITT v.29 scrambler
//
// (C) Copyright 1999 Araneus Information Systems Oy.  All rights reserved.
// Please refer to the file COPYRIGHT for detailed copyright information.
//

#ifndef _SCRAMBLER_H
#define _SCRAMBLER_H

#include <assert.h>

class V29Scrambler {
public:
    V29Scrambler() { reset(); }
    void reset() { s = 0; } 
    int operator()(int i) {
	assert(i < 2);
	s <<= 1;
	int r = (i ^ s >> 18 ^ s >> 23) & 1;
	s |= r;
	return r;
    }
// private:
    int s;
};

class V29Descrambler {
public:
    V29Descrambler() { reset(); }
    void reset() { s = 0; }
    int operator()(int i) {
	assert(i < 2);	
	s <<= 1; s |= i;
	return (s >> 0 ^ s >> 18 ^ s >> 23) & 1;
    }
private:
    int s;
};

class DummyScrambler {
public:
    DummyScrambler() { reset(); }
    void reset() { }
    int operator()(int i) {
	assert(i < 2);
	return i;
    }
};

class DummyDescrambler {
public:
    DummyDescrambler() { reset(); }
    void reset() { }
    int operator()(int i) {
	assert(i < 2);
	return i;
    }
};

#endif

