// $Id: allpass.h,v 1.3 2002/07/05 02:27:53 gson Exp $
//
// Schroeder allpass filter
//
// (C) Copyright 1999 Araneus Information Systems Oy.  All rights reserved.
// Please refer to the file COPYRIGHT for detailed copyright information.
//

#ifndef _ALLPASS_H
#define _ALLPASS_H

#include "dsp.h"

template <class T, int N>
class Allpass {
public:
    Allpass() { delayed = 0; gain = -0.7; }
    T operator()(T input) {
	T a = input + gain * delayed;
	T result = delayed - gain * a;
	delayed = delay(a);
	return result;
    }
    Delay<T, N> delay;
    T delayed;
    float gain;
};

#endif
