// $Id: amplitude.cc,v 1.2 2006/10/16 12:46:05 gson Exp $
//
// Measure signal amplitude
//

#include <stdio.h>
#include <signal.h>

#include "dsp.h"

int
main(int argc, char **argv) {
    for (;;) {

	int n = 48000;
	
	double acc = 0;
	
	for (int i = 0; i < n; i++) {
	    int s0 = getchar();
	    if (s0 == -1)
		goto done;
	    int s1 = getchar();
	    if (s1 == -1)
		goto done;
	    
	    short raw_sample = (s0 & 0xff) | ((s1 & 0xff) << 8);
	    float s = raw_sample * (1.0 / 32768);
	    
	    acc += s * s;
	}

	double amplitude = sqrt(acc / n);
	double db = log10(amplitude) * 20;
	if (db < -80)
	    db = -80;
	printf("%f\n", db);
    }
 done: ;
}
