// $Id: ccfft.cc,v 1.2 2005/03/07 14:10:25 gson Exp $

// Fast Fourier transform

// (C) Copyright 1992, 1998, 2002 Andreas Gustafsson

#include <stdio.h>
#include <math.h>
#include <stdlib.h>

#include "fft.h"
    
static inline bool
is_power_of_two(unsigned int n) {
    return ((n & (n - 1)) == 0);
}

//****************************************************************

int main(int argc, char **argv)
{
    int inv = 0;
    int n;
    int i;
    complex<double> *a;
    
    if (argv[1][0] == '-' && argv[1][1] == 'i') {
	inv = 1;
	++argv;
    }
  
    n = atoi(argv[1]);
    a = new complex<double>[n];

    for (i = 0; i < n; i++) {
	int nvalid;
	char buf[256];
	char *r;
	
	r = fgets(buf, 256, stdin);
	if (! r) {
	    a[i] = complex<double>(0, 0);
	} else {
	    double re, im;
	    nvalid = sscanf(buf, "%lf %lf", &re, &im);
	    if (nvalid < 2)
		im = 0;
	    a[i] = complex<double>(re, im);
	    if (inv)
		a[i] = conj(a[i] * ((double) 1.0 / n));
	}
    }
    if (is_power_of_two(n)) {
	fft<double> f(n);
	f.transform(a);	
    } else {
	dft<double> f(n);
	f.transform(a);
    }
    for (i = 0; i < n; i++) {
	printf("%g %g\n", a[i].real(), a[i].imag());
    }
    return 0;
}
