// $Id: channel.cc,v 1.18 2001/07/04 22:46:42 gson Exp $
//
// Simplex channel simulation with clock drift and AGWN.
//
// (C) Copyright 1999 Araneus Information Systems Oy.  All rights reserved.
// Please refer to the file COPYRIGHT for detailed copyright information.
//

#include <stdio.h>
#include <stdlib.h>

#include "fileio.h"
#include "resample-pull.h"
#include "window-functions.h"
#include "noise.h"

template <int N>
class Lowpass97 {
public:
    double operator()(double x) {
	return sinc(x * 0.97) * GaussianWindow(3.0)(x / (N/2));
    }
};

int main(int argc, char **argv)
{
    double fq = 1.0;
    double phase = 0.0;
    if (argc > 1)
	fq = atof(argv[1]);
    if (argc > 2)
	phase = atof(argv[2]);
    
    BinaryFileReader reader(stdin);
    PullSampleRateConverter<float, BinaryFileReader, Lowpass97<64>, 64, 64, 6>
	converter(reader);
    BinaryFileWriter writer(stdout);

    converter.fq = fq;
    converter.phase = phase;

    while (! reader.eof)
	writer.push(converter() + normal_random() * 0.01);
}

