// $Id: chirp.cc,v 1.1 2004/11/26 19:25:17 gson Exp $
//
// Generate a chirp test signal.
//
// (C) Copyright 1999-2002 Araneus Information Systems Oy.  All rights reserved.
// Please refer to the file COPYRIGHT for detailed copyright information.
//

#include <stdio.h>

#include "math.h"
#include "stdlib.h"
#include "fileio.h"

const float sample_rate = 48000.0f; // Hz

const float chirplen = 2.0f; // seconds

int main(int, char **argv)
{
    const float logfq_start = logf(20.0f / sample_rate);
    const float logfq_end = logf(20000.0f / sample_rate);
    const float logfq_step = (logfq_end - logfq_start) / (sample_rate * chirplen);

    BinaryFileWriter wr(stdout);

    double w = 0;
    for (;;) {
	for (float logfq = logfq_start; logfq <= logfq_end; logfq += logfq_step) {
	    float fq = expf(logfq);
	    wr.push(cos(w));
	    w += fq * M_PI * 2;
	    if (w > 2 * M_PI)
		w -= 2 * M_PI;
	}
    }
}
