// $Id: fdpipe.cc,v 1.5 1999/03/23 18:45:47 gson Exp $
//
// Full duplex audio I/O for use in pipelines.
//
// (C) Copyright 1999 Araneus Information Systems Oy.  All rights reserved.
// Please refer to the file COPYRIGHT for detailed copyright information.
//

// Simultaneously plays audio data from stdin and records onto stdout.
//
// Example: sine_generator | fdpipe | spectrum_analyzer.

#include <stdio.h>

#include "open-audio.h"
#include "audio-io.h"
#include "fileio.h"

int main(int argc, char **argv)
{
    BinaryFileReader in(stdin);
    BinaryFileWriter out(stdout);

    if (argc < 2) {
        fprintf(stderr, "usage: fdpipe /dev/sound\n");
        exit(1);
    }
    int audio_fd = open_audio(argv[1]);

    AudioIO audio(audio_fd);

    for (int i = 0; i < 3000; i++)
	audio.push(0);
    audio.start_input();
    audio.start_output();    
    
    while (! in.eof) {
	int size = audio.size();
	for (int i = 0; i < size; i++) {
	    out.push(audio());
	    audio.push(in());
	}
	usleep(20000);
    }
}
