// $Id: interpolator.h,v 1.4 1999/01/28 21:33:32 gson Exp $
//
// Interpolate by a factor of two.
//
// (C) Copyright 1999 Araneus Information Systems Oy.  All rights reserved.
// Please refer to the file COPYRIGHT for detailed copyright information.
//

#include "dsp.h"
#include "lowpass.h"
#include "window-functions.h"

// Interpolate by a factor of two, using a
// a polyphase FIR filter of length N.   The input samples are
// read from the object "input", of type I.

template <class T, int N, class I> 
class Interpolator
{
public:
    Interpolator(I &input)
	: inp(input), flip(0)
    {
	design_lowpass(fir.length(), fir.w, GaussianWindow(3.8), 1.0, 0.5);
    }

    T operator()() {
	T r = flip ? fir[N/2-1] : fir(inp());
	flip ^= 1;
	return r;
    }

private:    
    I &inp;
    int flip;
    FIR<T, N> fir;
};

