// $Id: loopback.cc,v 1.1 2006/10/16 11:50:19 gson Exp $
//
// Sound card loopback test
//
// (C) Copyright 2006 Araneus Information Systems Oy.  All rights reserved.
// Please refer to the file COPYRIGHT for detailed copyright information.
//

#include <stdio.h>

#include "open-audio.h"
#include "audio-io.h"
#include "pll.h"

int main(int argc, char **argv)
{
    if (argc < 2) {
        fprintf(stderr, "usage: loopback /dev/sound\n");
        exit(1);
    }
    int audio_fd = open_audio(argv[1]);

    AudioIO audio(audio_fd);
    Osc osc(0.1); // 0.1 rad/sample = 764 Hz @ fs = 48 kHz
    PLL pll(0.101);

    for (int i = 0; i < 3000; i++)
	audio.push(0);
    audio.start_input();
    audio.start_output();    

    for (;;) {
	int size = audio.size();
	for (int i = 0; i < size; i++) {
	    pll(audio());
	    audio.push(osc());
	}
	usleep(20000);
	printf("pll locked = %d\n", pll.locked());
    }
}
