/*
 *
 * Measure execution time using performance counters
 *
 */

#include "measure.h"

int MSRdiff(MSR t1, MSR t2, int truncate_bits)
     /* returns t1 - t2 */
{
  int ret_val = 0;

  if(t1.high != t2.high)
    {
      ret_val = (t1.high - t2.high) << (32 - truncate_bits);
    }
  ret_val += ((int) (t1.low >> truncate_bits)) - ((int) (t2.low >> truncate_bits));

#ifdef DEBUG_PRINT
  printf("TSC1low = %u\nTSC1high = %u\n",  t1.low, t1.high);
  printf("TSC2low = %u\nTSC2high = %u\n", t2.low, t2.high);
#endif

  return ret_val;
}

float TSCdiff_to_sec(int diff, int truncate_bits)
{
  return (float) diff * (1 << truncate_bits) / CPS;
}

/* At 0 truncation, it has an error of +17 cycles */



