// $Id: noise.h,v 1.2 1999/01/28 21:33:32 gson Exp $
//
// Gaussian white noise generator.
//
// (C) Copyright 1999 Araneus Information Systems Oy.  All rights reserved.
// Please refer to the file COPYRIGHT for detailed copyright information.
//

#ifndef _NOISE_H
#define _NOISE_H

#include <stdlib.h>
#include <math.h>

// Return a uniformly distributed random number in the range [0,1).

double uniform_random() {
    double t = (double) random() + (double) random() / 1073741824.0;
    return t / 2147483648.0;
}

// Return a normally distributed random numer with mean zero and
// standard deviation one.
//
// Polar method due to G. E. P. Box, M. E. Muller, and G. Marsaglia.
// See Knuth vol 2 page 117.

double normal_random() {
 again:
    double v1 = 2.0 * uniform_random() - 1.0;
    double v2 = 2.0 * uniform_random() - 1.0;
    double s = v1 * v1 + v2 * v2;
    if (s >= 1)
	goto again;
    return v1 * sqrt((-2 * log(s)) / s);
}

#endif
