#!/bin/sh
#
# $Id: plot-pr-spectrum.sh,v 1.7 1999/01/29 07:10:09 gson Exp $
#
# Plot the spectrum of various partial response systems.
#
# (C) Copyright 1999 Araneus Information Systems Oy.  All rights reserved.
# Please refer to the file COPYRIGHT for detailed copyright information.
#

# Plot the spectrum of the QAM baseband signal pulse shape.

coders="ModifiedDuoBinary AuDSL2 AuDSL6"

for coder in $coders
do
  g++ -I.. -DCODER=$coder test-pr.cc ../pr.cc -lm -o test-pr
  test-pr | sh plot-spectrum.sh --finite --linear --pipe >/tmp/$coder
done

list=`perl -e 'print join(", ", map { "\"/tmp/$_\"" } @ARGV)' $coders`

cat >/tmp/tmp.gp <<END
set data style lines
set xrange [0:256]
set samples 512
plot $list

pause -1
END

gnuplot /tmp/tmp.gp

