#!/bin/sh
#
# $Id: plot-pulse-spectrum.sh,v 1.5 1999/01/29 07:10:10 gson Exp $
#
# Plot the spectrum of the QAM baseband signal pulse.
#
# (C) Copyright 1999 Araneus Information Systems Oy.  All rights reserved.
# Please refer to the file COPYRIGHT for detailed copyright information.
#

mode=$1
case $mode in
  --qam) gain=3.0 ;;
  --pam|--sqam) gain=1.5 ;;
esac

make test-pulse-shaper

test-pulse-shaper $mode 24 | sh plot-spectrum.sh --finite --linear --pipe >/tmp/sp1

awk '{print $1 / '$gain'}' < /tmp/sp1 >/tmp/spnorm
awk '{print $1 * $1}' < /tmp/spnorm >/tmp/spsqr

cat >/tmp/tmp.gp <<END
set data style lines
set xrange [0:256]
set samples 512
plot "/tmp/spnorm", "/tmp/spsqr", (x>128), (x>128*2.0/3.0), (x>256*2.0/3.0)
pause -1
END

gnuplot /tmp/tmp.gp

