// $Id: resample-stereo.cc,v 1.3 1999/01/28 21:33:33 gson Exp $
//
// Sample rate convert a stereo signal.
//
// (C) Copyright 1999 Araneus Information Systems Oy.  All rights reserved.
// Please refer to the file COPYRIGHT for detailed copyright information.
//

#include <stdio.h>
#include <stdlib.h>
#include <complex>

#include "fileio.h"
#include "resample-complex-mmx.h"
#include "pull-src.h"
#include "window-functions.h"

template <int N>
class Lowpass97 {
public:
    double operator()(double x) {
	return sinc(x * 0.97) * GaussianWindow(3.0)(x / (N/2));
    }
};

int main(int argc, char **argv)
{
    double fq = 1.0;
    double phase = 0.0;
    if (argc > 1)
	fq = atof(argv[1]);
    if (argc > 2)
	phase = atof(argv[2]);
    
    BinaryFileReader reader(stdin);
    PullSampleRateConverter<complex<s16>, BinaryFileReader, Lowpass97<64>, 64, 64>
	converter(reader);
    BinaryFileWriter writer(stdout);

    converter.fq = fq;
    converter.phase = phase;

    while (! reader.eof)
	writer.push(converter().real());
}
