// $Id: reverb.cc,v 1.2 1999/03/25 16:17:02 gson Exp $
//
// Reverb
//
// (C) Copyright 1999 Araneus Information Systems Oy.  All rights reserved.
// Please refer to the file COPYRIGHT for detailed copyright information.
//

#include <stdio.h>

#include "open-audio.h"
#include "audio-io.h"
#include "allpass.h"

int main(int argc, char **argv)
{
    if (argc < 2) {
        fprintf(stderr, "usage: reverb /dev/sound\n");
        exit(1);
    }
    int audio_fd = open_audio(argv[1]);

    AudioIO audio(audio_fd);

    for (int i = 0; i < 3000; i++)
	audio.push(0);
    audio.start_input();
    audio.start_output();    

    Allpass<float, 1> ap0;
    Allpass<float, 3> ap1;
    Allpass<float, 7> ap2;    
    Allpass<float, 127> ap3;    
    Allpass<float, 379> ap4;    
    Allpass<float, 1013> ap5;    
    Allpass<float, 3109> ap6;  
    Allpass<float, 9001> ap7;  
    Allpass<float, 20011> ap8;  

    for (;;) {
	int size = audio.size();
	for (int i = 0; i < size; i++) {
	    float t = audio();
	    t = ap0(t);
	    t = ap1(t);
	    t = ap2(t);
	    t = ap3(t);
	    t = ap4(t);
	    t = ap5(t);
	    t = ap6(t);
	    t = ap7(t);
	    t = ap8(t);	    
	    audio.push(t);
	}
	usleep(20000);
    }
}
