// $Id: test-echo-audio.cc,v 1.3 1999/01/28 21:33:34 gson Exp $
//
// Test echo canceller against audio device.
//
// (C) Copyright 1999 Araneus Information Systems Oy.  All rights reserved.
// Please refer to the file COPYRIGHT for detailed copyright information.
//

#include <stdio.h>

#include "open-audio.h"
#include "mmap-audio.h"
#include "audio-io.h"
#include "fileio.h"

#include "echo.h"

int main(int argc, char **argv)
{
    int audio_fd = open_audio("/dev/sound");

    AudioIO audio(audio_fd);

    struct ZeroSource {
	int operator()() { return 0; }
    } zero_source;
    
    struct DummySink {
	void push(int) { }
    } dummy_sink;

    
    EchoCanceller<float, 32768, 32, AUDIO, AUDIO, ZeroSource, DummySink>
	canceller(audio, audio, zero_source, dummy_sink);
    
    for (int i = 0; i < 3000; i++)
	audio.push(0);
    
    for (;;) {
	int size = audio.size();
	// fprintf(stderr, "%d\n", size);
	for (int i = 0; i < size; i++) {
	    canceller.run();
	}
	usleep(20000);
    }
}
