// $Id: test-hdlc-rx.cc,v 1.5 2004/11/26 19:03:58 gson Exp $
//
// Test harness for HDLC receiver.
//
// (C) Copyright 1999 Araneus Information Systems Oy.  All rights reserved.
// Please refer to the file COPYRIGHT for detailed copyright information.
//

#include <stdio.h>
#include <iostream>
#include <iomanip>
#include <string>
#include <ctype.h>
#include <stdlib.h>
#include <assert.h>

using std::cin;

#include "hdlc.h"

class HexWriter {
public:
    HexWriter() 
	: ndata(0) { }
    void push_flag() {
	if (ndata) printf("\n");
	ndata = 0;
    }
    void push_bits(int d, int
#ifndef NDEBUG
		   nbits
#endif
		   ) {
	assert(nbits == 8);
	if (ndata) printf(" ");
	printf("%02X", d);
	ndata++;
    }
private:
    int ndata;
};

int main(int, char **)
{
    HexWriter hw;
    HDLCDeframer<HexWriter> deframer(hw);
    for (;;) {
	int c = cin.get();
	if (c == EOF) {
	    exit(1);
	} else if (c == '0') {
	    deframer.run(0);
	} else if (c == '1') {
	    deframer.run(1);
	}
    }
}
