// $Id: test-pam-rx.cc,v 1.8 2006/10/18 12:12:09 gson Exp $
//
// Test harness for PR-PAM receiver.
//
// (C) Copyright 1999 Araneus Information Systems Oy.  All rights reserved.
// Please refer to the file COPYRIGHT for detailed copyright information.
//
#include <stdlib.h>
#include <math.h>
#include <assert.h>

#include "pam-rx.h"
#include "fileio.h"
#include "bitfileio.h"

int main(int, char **) {
    BinaryFileReader reader(stdin);
    BitFileWriter writer(stdout);

    PRPAMReceiver<float, BinaryFileReader, BitFileWriter, 16> rx(reader, writer);
	
    while (! reader.eof) {
	rx.run();
    }

    // Print the mean square error residual
    fprintf(stderr, "%f\n", sqrt(rx.mse));

    exit(0);
}


