// $Id: test-polyphase-fir.cc,v 1.2 1999/06/29 18:31:32 gson Exp $
//
// Test harness for polyphase FIR filter.
//
// (C) Copyright 1999 Araneus Information Systems Oy.  All rights reserved.
// Please refer to the file COPYRIGHT for detailed copyright information.
//

#include <stdio.h>
#include <stdlib.h>

#include "fileio.h"
#include "polyphase-fir.h"
#include "window-functions.h"
#include "kernels.h"

template <int N>
class Lowpass {
public:
    double operator()(double x) const {
	return sinc(x * 1.0) * GaussianWindow(2.5)(x / (N/2));
    }
};

int main(int, char **)
{
    BinaryFileReader reader(stdin);
    // Lowpass<64> kernel;
    GaussianWindowedBandpassKernel kernel(4.0/24, 20.0/24, 64, 2.5);
    PullPolyphaseFIR<float, BinaryFileReader, GaussianWindowedBandpassKernel, 64, 3>
	converter(reader, kernel, 2);
    BinaryFileWriter writer(stdout);

    while (! reader.eof)
	writer.push(converter());
}

