// $Id: test-qam-rx.cc,v 1.11 2006/10/18 12:12:09 gson Exp $
//
// Test harness for QAM receiver.
//
// (C) Copyright 1999 Araneus Information Systems Oy.  All rights reserved.
// Please refer to the file COPYRIGHT for detailed copyright information.
//

#include "qam-rx.h"
#include "fileio.h"
#include "bitfileio.h"

int main(int, char **) {
    BinaryFileReader reader(stdin);
    BitFileWriter writer(stdout);

    QAMReceiver<float, BinaryFileReader, BitFileWriter, 16> rx(reader, writer);

    while (! reader.eof) {
	rx.run();
    }

    // Print the mean square error residual
    fprintf(stderr, "%f\n", sqrt(rx.baseband_part.mse));
}

