// $Id: test-resample.cc,v 1.5 1999/05/09 11:41:57 gson Exp $
//
// Test mpulse response of irrational sample rate converter.
//
// (C) Copyright 1999 Araneus Information Systems Oy.  All rights reserved.
// Please refer to the file COPYRIGHT for detailed copyright information.
//

#include <iostream.h>

#include "resample-pull.h"
#include "dsp.h"
#include "window-functions.h"

template <int N>
class Lowpass97 {
public:
    double operator()(double x) {
	return sinc(x * 0.97) * GaussianWindow(3.0)(x / (N/2));
    }
};

int main(int argc, char **argv)
{
    Impulse<float> imp;
    PullSampleRateConverter<float, Impulse<float>, Lowpass97<64>, 64, 64, 6>
       converter(imp);
    converter.fq = 0.01;
    for (int i = 0; i < 6400; i++)
       cout << tofloat(converter()) << endl;
}
